<template>
  <div
    class="order-correction-route-point"
    :class="{
      '--is-static': isReadonly
    }"
  >
    <div class="top-panel">
      <div class="top-panel__left">
        <template v-if="isReadonly">
          <span class="point-type">
            {{ point.direction === 'FROM' ? 'Погрузка' : 'Разгрузка' }}
          </span>
        </template>
        <template v-else>
          <ObRadio
            :model-value="point.direction"
            label="Погрузка"
            valueInput="FROM"
            :disabled="isReadonly"
            data-qa="pointDirectionFrom"
            @change="onChangeField('direction', $event)"
          />
          <ObRadio
            :model-value="point.direction"
            label="Разгрузка"
            valueInput="TO"
            :disabled="isReadonly"
            data-qa="pointDirectionTo"
            @change="onChangeField('direction', $event)"
          />
        </template>
      </div>
      <div class="top-panel__right">
        <button
          v-if="!isReadonly && isRemovable"
          class="remove-point-button"
          @click="onRemovePoint"
        >
          <i class="icon close" />
        </button>
      </div>
    </div>
    <ObAddressInput
      :address="point.addressTitle"
      display-exp="russian_address"
      title="Адрес"
      placeholder="Укажите адрес"
      :disabled="isReadonly"
      @input="onSetLocation"
      @on-change-address="onSetLocation"
    />
    <div class="dates-panel">
      <ObDatePicker
        :value="point.slotStartAt"
        :is-time="true"
        data-qa="pointSlotStartAt"
        :disabled="isReadonly"
        class="dates-panel__item"
        @input="onChangeField('slotStartAt', $event)"
      />
      <ObDatePicker
        :value="point.slotEndAt"
        :is-time="true"
        data-qa="pointSlotEndAt"
        :disabled="isReadonly"
        class="dates-panel__item"
        @input="onChangeField('slotEndAt', $event)"
      />
    </div>
  </div>
</template>

<script>
import ObRadio from 'common-components/src/obComponents/obRadio'
import ObAddressInput from 'common-components/src/obComponents/obAddressInput'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'

export default {
  name: 'OrderCorrectionRoutePoint',
  components: {
    ObRadio,
    ObAddressInput,
    ObDatePicker
  },
  props: {
    point: {
      type: Object,
      default: () => {}
    },
    isReadonly: {
      type: Boolean,
      default: false
    },
    isRemovable: {
      type: Boolean,
      default: true
    }
  },
  methods: {
    onChangeField (key, value) {
      this.$emit('change', { key, value })
    },
    onSetLocation (point) {
      const { label } = point

      this.onChangeField('addressTitle', label)
    },
    onRemovePoint () {
      this.$emit('remove')
    }
  },
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.order-correction-route-point {
  margin-bottom: 15px;
  padding: 24px 20px 24px 44px;
  box-shadow: 0 0 2px rgba(0, 75, 200, 0.15), 0 0 12px rgba(0, 75, 200, 0.04), 0 4px 10px rgba(0, 75, 200, 0.06);
  border-radius: 4px;
  &.--is-static {
    padding-left: 20px;
    padding-top: 20px;
  }
  .top-panel {
    display: flex;
    align-items: center;
    justify-content: space-between;
    margin-bottom: 15px;
    &__left {
      display: flex;
      align-items: center;
      .point-type {
        @include font-mixin(16px, 20px, 400);
      }
      &::v-deep {
        .ob-radio-container {
          margin-right: 12px;
        }
      }
    }
    &__right {
      .remove-point-button {
        margin: 0;
        padding: 0;
        border: none;
        background-color: transparent;
        outline: none;
        cursor: pointer;
        &:hover {
          opacity: 0.8;
        }
        .icon {
          font-size: 20px;
          color: $color-grey-label;
        }
      }
    }
  }
  .dates-panel {
    display: flex;
    align-items: center;
    margin-top: 15px;
    &__item {
      width: 190px;
      margin-right: 20px;
      &::v-deep {
        .ob-input-wrap {
          height: 30px;
          label {
            display: none;
          }
          .main-icon {
            i {
              font-size: 16px;
            }
          }
          input {
            font-size: 14px;
          }
        }
      }
    }
  }
}
</style>